From 68f92a71f78750f2393c3bff2e2cdedb9c06da45 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 21 2017 09:44:19 +0000
Subject: [PATCH 805/1001] Add Halp widget


---

diff --git a/hubs/default_config.py b/hubs/default_config.py
index 5837486..72cda31 100644
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -44,6 +44,7 @@ CHAT_NETWORKS = [
     }
 ]
 
+DATAGREPPER_URI = 'https://apps.fedoraproject.org/datagrepper'
 
 WIDGETS = [
     'hubs.widgets.about:About',
@@ -58,6 +59,7 @@ WIDGETS = [
     'hubs.widgets.fhosted:FedoraHosted',
     'hubs.widgets.github_pr:GitHubPRs',
     'hubs.widgets.githubissues:GitHubIssues',
+    'hubs.widgets.halp:Halp',
     'hubs.widgets.meetings:Meetings',
     'hubs.widgets.memberships:Memberships',
     'hubs.widgets.pagure_pr:PagurePRs',
diff --git a/hubs/defaults.py b/hubs/defaults.py
index 2d27239..7bda776 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -82,6 +82,12 @@ def add_user_widgets(session, hub, username, fullname):
             'username': username,
         }))
     hub.widgets.append(widget)
+    hub.widgets.append(
+        hubs.models.Widget(
+            plugin='halp', index=9,
+            _config=json.dumps({
+            }))
+        )
     return hub
 
 
diff --git a/hubs/static/client/app/components/CompletionInput.jsx b/hubs/static/client/app/components/CompletionInput.jsx
new file mode 100644
index 0000000..9b8b581
--- /dev/null
+++ b/hubs/static/client/app/components/CompletionInput.jsx
@@ -0,0 +1,150 @@
+import React from 'react';
+import Autosuggest from 'react-autosuggest';
+
+
+export default class CompletionInput extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      value: "",
+      suggestions: [],
+      loading: false
+    }
+    this.resultsDomNodeStyle = {
+      position: "absolute",
+      width: "auto"
+    }
+    this.queryTimeout = null;
+    this.onResultClick = this.onResultClick.bind(this);
+    this.onChange = this.onChange.bind(this);
+    this.onSuggestionsFetchRequested = this.onSuggestionsFetchRequested.bind(this);
+    this.onSuggestionsClearRequested = this.onSuggestionsClearRequested.bind(this);
+    this.onSuggestionSelected = this.onSuggestionSelected.bind(this);
+    this.loadFromServer = this.loadFromServer.bind(this);
+  }
+
+  componentWillUnmount() {
+    if (this.serverRequest) { this.serverRequest.abort(); }
+  }
+
+  onResultClick(result) {
+    this.setState({
+      results: [],
+      value: result
+    });
+  }
+
+  onChange(e, {newValue}) {
+    this.setState({
+      value: newValue
+    });
+  }
+
+  onSuggestionSelected(e, {suggestionValue}) {
+    // Transmit a "fake" changed event to the parent, if asked to.
+    if (!this.props.onChange) { return; }
+    const mockedEvent = {
+      type: 'change',
+      target: {
+        type: 'input',
+        name: this.props.name,
+        value: suggestionValue,
+      },
+    }
+    this.props.onChange(mockedEvent);
+  }
+
+  // Autosuggest will call this function every time you need to update
+  // suggestions.
+  onSuggestionsFetchRequested({value}) {
+    var inputValue = value.trim().toLowerCase();
+    if (this.queryTimeout !== null) {
+      window.clearTimeout(this.queryTimeout);
+    }
+    if (this.serverRequest) { this.serverRequest.abort(); }
+    if (inputValue.length === 0) {
+      this.setState({
+        suggestions: [],
+        loading: false
+      });
+    } else {
+      this.queryTimeout = window.setTimeout(
+        this.loadFromServer, this.props.queryDelay, inputValue);
+    }
+  }
+
+  loadFromServer(value) {
+    this.setState({loading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.url,
+      method: 'GET',
+      data: {q: value},
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          suggestions: data.results,
+          loading: false
+        });
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.url, status, err.toString());
+        this.setState({loading: false});
+      }.bind(this)
+    });
+  }
+
+  // Autosuggest will call this function every time you need to clear
+  // suggestions.
+  onSuggestionsClearRequested() {
+    this.setState({
+      suggestions: []
+    });
+  }
+
+  render() {
+    // When a suggestion is clicked, this method will return the value to
+    // populate the input with.
+    const getSuggestionValue = suggestion => suggestion;
+    // Render suggestions.
+    const renderSuggestion = suggestion => suggestion;
+    // Autosuggest will pass through all these props to the input element.
+    const inputProps = {
+      //placeholder: 'Type a programming language',
+      name: this.props.name,
+      className: "form-control",
+      value: this.state.value,
+      placeholder: this.props.placeholder,
+      onChange: this.onChange,
+    };
+
+    // Render the widget.
+    return (
+      <div className="completion-input">
+        <Autosuggest
+          suggestions={this.state.suggestions}
+          onSuggestionsFetchRequested={this.onSuggestionsFetchRequested}
+          onSuggestionsClearRequested={this.onSuggestionsClearRequested}
+          onSuggestionSelected={this.onSuggestionSelected}
+          getSuggestionValue={getSuggestionValue}
+          renderSuggestion={renderSuggestion}
+          inputProps={inputProps}
+        />
+        { this.state.loading ?
+          <span className="form-control-feedback">
+            <img src={this.props.spinner} />
+          </span>
+        : null }
+      </div>
+    );
+  }
+
+}
+CompletionInput.defaultProps = {
+    placeholder: "",
+    queryDelay: 800,
+};
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/Modal.jsx b/hubs/static/client/app/components/Modal.jsx
new file mode 100644
index 0000000..1ba31b1
--- /dev/null
+++ b/hubs/static/client/app/components/Modal.jsx
@@ -0,0 +1,109 @@
+import React from 'react';
+
+
+export default class Modal extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.onShow = this.onShow.bind(this);
+    this.onShown = this.onShown.bind(this);
+    this.onHide = this.onHide.bind(this);
+    this.onHidden = this.onHidden.bind(this);
+    this.hide = this.hide.bind(this);
+    this.show = this.show.bind(this);
+    this.getModalBody = this.getModalBody.bind(this);
+    this.getModalFooter = this.getModalFooter.bind(this);
+  }
+
+  componentDidMount() {
+    if (this.domNode) {
+      $(this.domNode).on("show.bs.modal", this.onShow);
+      $(this.domNode).on("shown.bs.modal", this.onShown);
+      $(this.domNode).on("hide.bs.modal", this.onHide);
+      $(this.domNode).on("hidden.bs.modal", this.onHidden);
+    }
+  }
+
+  componentWillUnmount() {
+    if (this.domNode) {
+      $(this.domNode).off("show.bs.modal", this.onShow);
+      $(this.domNode).off("shown.bs.modal", this.onShown);
+      $(this.domNode).off("hide.bs.modal", this.onHide);
+      $(this.domNode).off("hidden.bs.modal", this.onHidden);
+    }
+  }
+
+  onShow(e) {
+    if (this.props.onShow) { this.props.onShow(); }
+  }
+  onShown(e) {
+    if (this.props.onShown) { this.props.onShown(); }
+  }
+  onHide(e) {
+    if (this.props.onHide) { this.props.onHide(); }
+  }
+  onHidden(e) {
+    if (this.props.onHidden) { this.props.onHidden(); }
+  }
+
+  hide(callback) {
+    if (!this.domNode) { return; }
+    var domNode = $(this.domNode);
+    if (callback) { domNode.one("hidden.bs.modal", callback); }
+    domNode.modal("hide");
+  }
+
+  show(callback) {
+    if (!this.domNode) { return; }
+    var domNode = $(this.domNode);
+    if (callback) { domNode.one("shown.bs.modal", callback); }
+    $(this.domNode).modal("show");
+  }
+
+  componentWillUpdate(nextProps, nextState) {
+    if (!nextProps.open) { this.hide(); }
+  }
+
+  componentDidUpdate() {
+    if (this.props.open) { this.show(); }
+  }
+
+  getModalBody() {
+    if (!this.props.data) { return ""; }
+  }
+
+  getModalFooter() {
+    return null;
+  }
+
+  render() {
+    var footer = this.getModalFooter();
+    return (
+      <div className="modal fade" role="dialog" ref={(ref) => this.domNode = ref}>
+        <div className="modal-dialog" role="document">
+          <div className="modal-content">
+            <div className="modal-header">
+              <button type="button" className="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
+              <h4 className="modal-title">{this.props.title}</h4>
+            </div>
+            <div className="modal-body">
+              {this.getModalBody()}
+            </div>
+            {footer ?
+            <div className="modal-footer">
+              {footer}
+            </div>
+             : null}
+          </div>
+        </div>
+      </div>
+    );
+  }
+}
+Modal.propTypes = {
+    open: React.PropTypes.bool,
+    data: React.PropTypes.object
+};
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/Halp.jsx b/hubs/static/client/app/widgets/halp/Halp.jsx
new file mode 100644
index 0000000..f1db852
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Halp.jsx
@@ -0,0 +1,182 @@
+import React from 'react';
+import {
+  IntlProvider,
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import HubsList from './HubsList.jsx';
+import ModalRequest from './ModalRequest.jsx';
+import ModalAllRequests from './ModalAllRequests.jsx';
+import Request from './Request.jsx';
+
+
+const messages = defineMessages({
+  no_request: {
+    id: "hubs.widgets.halp.no_request",
+    defaultMessage: "No request for now."
+  },
+  view_more: {
+    id: "hubs.widgets.halp.view_more",
+    defaultMessage: "View more"
+  },
+  zoom_title: {
+    id: "hubs.widgets.halp.zoom.title",
+    defaultMessage: "Help request"
+  },
+  search_title: {
+    id: "hubs.widgets.halp.search.title",
+    defaultMessage: "All Help Requests"
+  },
+});
+
+
+export default class HalpWidget extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      requests: [],
+      inactiveHubs: [],
+      zoomedRequest: null,
+      allRequestsOpen: false,
+      loading: false
+    };
+    this.zoomOnRequest = this.zoomOnRequest.bind(this);
+    this.onZoomClose = this.onZoomClose.bind(this);
+    this.openAllRequests = this.openAllRequests.bind(this);
+    this.onAllRequestsClose = this.onAllRequestsClose.bind(this);
+    this.onHubClick = this.onHubClick.bind(this);
+  }
+
+  loadFromServer() {
+    this.setState({loading: true});
+    var data = { hubs: [] };
+    this.props.hubs.forEach(function(hub) {
+      if (this.state.inactiveHubs.indexOf(hub) === -1) {
+        data.hubs.push(hub);
+      }
+    }.bind(this));
+    this.serverRequest = $.ajax({
+      url: this.props.urls.data,
+      method: 'GET',
+      data: $.param(data, true),
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          requests: data.requests,
+          loading: false
+        });
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.urls.data, status, err.toString());
+        this.setState({loading: false});
+      }.bind(this)
+    });
+  }
+
+  componentDidMount() {
+    this.loadFromServer();
+  }
+
+  componentWillUnmount() {
+    this.serverRequest.abort();
+  }
+
+  zoomOnRequest(request) {
+    this.setState({zoomedRequest: request});
+  }
+  onZoomClose() {
+    this.setState({zoomedRequest: null});
+  }
+
+  openAllRequests(e) {
+    e.preventDefault();
+    this.setState({allRequestsOpen: true});
+  }
+  onAllRequestsClose() {
+    this.setState({allRequestsOpen: false});
+  }
+
+  onHubClick(hubName) {
+    var newInactiveHubs = this.state.inactiveHubs.slice(),
+        inactiveIndex = this.state.inactiveHubs.indexOf(hubName);
+    if (inactiveIndex === -1) {
+      newInactiveHubs.push(hubName);
+    } else {
+      newInactiveHubs.splice(inactiveIndex, 1);
+    }
+    this.setState(
+      { inactiveHubs: newInactiveHubs },
+      this.loadFromServer);
+  }
+
+  render() {
+    var requestNodes;
+    if (this.state.requests.length === 0) {
+      requestNodes = (
+        <p className="no-request">
+          <FormattedMessage {...messages.no_request} />
+        </p>
+        );
+    } else {
+      var previousDate = null;
+      requestNodes = this.state.requests.map(function(request, idx) {
+        var showDate = (request.date !== previousDate);
+        previousDate = request.date;
+        return (
+          <Request
+            request={request}
+            showdate={showDate}
+            onZoomRequest={this.zoomOnRequest}
+            key={idx} />
+        );
+      }.bind(this));
+    }
+    var hubs = this.props.hubs.map(function(hub) {
+      return {
+        name: hub,
+        active: (this.state.inactiveHubs.indexOf(hub) === -1)
+      }
+    }.bind(this));
+    return (
+      <IntlProvider locale={navigator.language}>
+        <div className="widget-halp">
+          <HubsList
+            hubs={hubs}
+            onHubClick={this.onHubClick}
+            />
+          { this.state.loading ?
+              <img className="center-block" src={this.props.urls.spinner} />
+            :
+              <div className="requests">
+                {requestNodes}
+              </div>
+          }
+          <div className="view-more text-muted">
+            <button className="btn btn-secondary" onClick={this.openAllRequests}>
+              <FormattedMessage {...messages.view_more} />
+              &nbsp; <span className="fa fa-chevron-right" aria-hidden="true"></span>
+            </button>
+          </div>
+          <ModalRequest
+            open={this.state.zoomedRequest !== null}
+            data={this.state.zoomedRequest}
+            title={<FormattedMessage {...messages.zoom_title} />}
+            onHidden={this.onZoomClose} />
+          <ModalAllRequests
+            open={this.state.allRequestsOpen}
+            onHidden={this.onAllRequestsClose.bind(this)}
+            onZoomRequest={this.zoomOnRequest}
+            title={<FormattedMessage {...messages.search_title} />}
+            urls={this.props.urls}
+            hubs={hubs}
+            />
+        </div>
+      </IntlProvider>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/Hub.jsx b/hubs/static/client/app/widgets/halp/Hub.jsx
new file mode 100644
index 0000000..044e6d9
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Hub.jsx
@@ -0,0 +1,23 @@
+import React from 'react';
+
+
+export default class Hub extends React.Component {
+
+  onClick(e) {
+    e.preventDefault();
+    this.props.onClick(this.props.name);
+  }
+
+  render() {
+    var activeClass = this.props.active ? "active" : "inactive";
+    return (
+      <span
+        className={"hub " + activeClass}
+        onClick={this.onClick.bind(this)}
+        >{"@" + this.props.name}</span>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/HubsList.jsx b/hubs/static/client/app/widgets/halp/HubsList.jsx
new file mode 100644
index 0000000..3915dd4
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/HubsList.jsx
@@ -0,0 +1,43 @@
+import React from 'react';
+import { defineMessages, FormattedMessage } from 'react-intl';
+import Hub from './Hub.jsx';
+
+
+const messages = defineMessages({
+  watching_all_hubs: {
+    id: "hubs.widgets.halp.watching_all_hubs",
+    defaultMessage: "Watching all hubs"
+  },
+});
+
+
+export default class HubsList extends React.Component {
+  render() {
+    var hubNodes = this.props.hubs.map(function(hub, idx) {
+      return (
+        <Hub
+          name={hub.name}
+          active={hub.active}
+          onClick={this.props.onHubClick}
+          key={idx}
+          />
+      );
+    }.bind(this));
+    return (
+      <div className="hubs row">
+        <span className="fa fa-tags" aria-hidden="true"></span>
+        { (hubNodes.length !== 0) ?
+            hubNodes
+          :
+            <FormattedMessage
+              tagName="em"
+              {...messages.watching_all_hubs}
+              />
+        }
+      </div>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx b/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx
new file mode 100644
index 0000000..c3d13cd
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/ModalAllRequests.jsx
@@ -0,0 +1,234 @@
+import { defineMessages, FormattedMessage } from 'react-intl';
+import CompletionInput from '../../components/CompletionInput.jsx';
+import Modal from '../../components/Modal.jsx';
+import Request from './Request.jsx';
+
+
+const messages = defineMessages({
+  no_request_found: {
+    id: "hubs.widgets.halp.no_request_found",
+    defaultMessage: "No request found."
+  },
+  search_meeting_name: {
+    id: "hubs.widgets.halp.search.meeting_name",
+    defaultMessage: "Meeting name"
+  },
+  search_between_dates: {
+    id: "hubs.widgets.halp.search.between_dates",
+    defaultMessage: "Between dates"
+  },
+  search_people: {
+    id: "hubs.widgets.halp.search.people",
+    defaultMessage: "People"
+  },
+  search_button: {
+    id: "hubs.widgets.halp.search.button",
+    defaultMessage: "Search"
+  },
+  pager_newer: {
+    id: "hubs.widgets.halp.pager.newer",
+    defaultMessage: "Newer"
+  },
+  pager_older: {
+    id: "hubs.widgets.halp.pager.older",
+    defaultMessage: "Older"
+  },
+  pager_status: {
+    id: "hubs.widgets.halp.pager.status",
+    defaultMessage: "Page {page} / {total}"
+  },
+});
+
+
+export default class ModalAllRequests extends Modal {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      requests: [],
+      page: {nr: 1, has_prev: false, has_next: false},
+      formData: {
+        hubs: this.props.hubs.filter(
+            function(hub) { return hub.active; }
+          ).map(
+            function(hub) { return hub.name; }
+          ),
+        },
+      loading: false,
+    };
+    this.onSubmit = this.onSubmit.bind(this);
+    this.loadFromServer = this.loadFromServer.bind(this);
+    this.onZoomRequest = this.onZoomRequest.bind(this);
+    this.changePage = this.changePage.bind(this);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  componentWillUnmount() {
+    super.componentWillUnmount();
+    this.serverRequest.abort();
+  }
+
+  onShown(e) {
+    super.onShown(e);
+    if (this.state.requests.length === 0) { this.loadFromServer(); }
+  }
+
+  onHidden(e) {
+    super.onHidden(e);
+    if (this.serverRequest) { this.serverRequest.abort(); }
+  }
+
+  onZoomRequest(request) {
+    // Close this modal and open the request modal
+    this.hide(function() {
+      this.props.onZoomRequest(request);
+    }.bind(this));
+  }
+
+  onSubmit(e) {
+    e.preventDefault();
+    this.loadFromServer();
+  }
+
+  changePage(inc) {
+    var requestedPage = this.state.page.nr + inc;
+    this.loadFromServer(requestedPage);
+  }
+
+  loadFromServer(requestedPage) {
+    const formData = this.state.formData;
+    formData.page = requestedPage || 1;
+    this.setState({loading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.urls.search,
+      method: 'GET',
+      data: formData,
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          requests: data.requests,
+          page: data.page,
+          loading: false
+        });
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.urls.search, status, err.toString());
+        this.setState({loading: false});
+      }.bind(this)
+    });
+  }
+
+  handleChange(e) {
+    const value = e.target.type === 'checkbox' ? e.target.checked : e.target.value;
+    const name = e.target.name;
+    var data = this.state.formData;
+    data[name] = value;
+    this.setState({formData: data});
+  }
+
+  getModalBody() {
+    var requestNodes;
+    if (this.state.requests.length === 0) {
+      requestNodes = (<p className="no-request">
+        <FormattedMessage {...messages.no_request_found} />
+      </p>);
+    } else {
+      requestNodes = this.state.requests.map(function(request, idx) {
+        return (
+          <Request
+            request={request}
+            showdate={false}
+            onZoomRequest={this.onZoomRequest}
+            key={idx} />
+        );
+      }.bind(this));
+    }
+    return (
+      <div>
+        <form className="row form-horizontal" method="post"
+              action={this.props.urls.search} onSubmit={this.onSubmit}>
+          <div className="form-group">
+            <label htmlFor="meetingname" className="col-sm-4 control-label">
+              <FormattedMessage {...messages.search_meeting_name} />
+            </label>
+            <div className="col-sm-8">
+              <input type="text" className="form-control" name="meetingname"
+                     onChange={this.handleChange} />
+            </div>
+          </div>
+          <div className="form-group">
+            <label htmlFor="startdate" className="col-sm-4 control-label">
+              <FormattedMessage {...messages.search_between_dates} />
+            </label>
+            <div className="col-sm-4">
+              <input type="date" className="form-control" name="startdate"
+                     onChange={this.handleChange} />
+            </div>
+            <div className="col-sm-4">
+              <input type="date" className="form-control" name="enddate"
+                     onChange={this.handleChange} />
+            </div>
+          </div>
+          <div className="form-group">
+            <label htmlFor="people" className="col-sm-4 control-label">
+              <FormattedMessage {...messages.search_people} />
+            </label>
+            <div className="col-sm-8">
+              <CompletionInput
+                name="people"
+                url={this.props.urls.requesters}
+                spinner={this.props.urls.spinnerCircle}
+                onChange={this.handleChange} />
+            </div>
+          </div>
+          <div className="form-group">
+            <div className="col-sm-offset-4 col-sm-8">
+              <button type="submit" className="btn btn-primary">
+                <FormattedMessage {...messages.search_button} />
+              </button>
+              { this.state.loading && <img style={{marginLeft: "2em"}} src={this.props.urls.spinner} /> }
+            </div>
+          </div>
+        </form>
+        <hr />
+        <div className="requests">
+          {requestNodes}
+        </div>
+      </div>
+    );
+  }
+
+  getModalFooter() {
+    if (this.state.requests.length === 0
+        || (!this.state.page.has_prev && !this.state.page.has_next)) {
+      // No results or only one page: don't show the pager.
+      return null;
+    }
+    return (
+      <nav aria-label="...">
+        <ul className="pager">
+          <li className={"pager-prev" + (this.state.page.has_prev ? "" : " disabled")}>
+            <a href="#" onClick={this.changePage.bind(this, -1)}>
+              <span aria-hidden="true">&larr;</span>
+              <FormattedMessage {...messages.pager_newer} />
+              </a>
+          </li>
+          <FormattedMessage
+            tagName="li"
+            {...messages.pager_status}
+            values={{page: this.state.page.nr, total: this.state.page.total_pages}}
+            />
+          <li className={"pager-next" + (this.state.page.has_next ? "" : " disabled")}>
+            <a href="#" onClick={this.changePage.bind(this, 1)}>
+              <FormattedMessage {...messages.pager_older} />
+              <span aria-hidden="true">&rarr;</span></a>
+          </li>
+        </ul>
+      </nav>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/ModalRequest.jsx b/hubs/static/client/app/widgets/halp/ModalRequest.jsx
new file mode 100644
index 0000000..b6d0860
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/ModalRequest.jsx
@@ -0,0 +1,99 @@
+import { defineMessages, FormattedMessage } from 'react-intl';
+import Modal from '../../components/Modal.jsx';
+import getRequestView from './getRequestView.jsx';
+
+
+const messages = defineMessages({
+  zoom_part2_title: {
+    id: "hubs.widgets.halp.zoom.part2_title",
+    defaultMessage: "Want to help with this request?"
+  },
+  zoom_part2_subtitle: {
+    id: "hubs.widgets.halp.zoom.part2_subtitle",
+    defaultMessage: "Awesome! Here's some tips on getting started:"
+  },
+  zoom_tip1: {
+    id: "hubs.widgets.halp.zoom.tip1",
+    defaultMessage: "Take a look at the link provided in the request. It should have more information about the problem and may have instructions on how to get starter helping out:"
+  },
+  zoom_tip2: {
+    id: "hubs.widgets.halp.zoom.tip2",
+    defaultMessage: "Contact the person who requested help to get more information. By clicking on their name, you'll be taken to their profile where you can contact them:"
+  },
+  zoom_tip3: {
+    id: "hubs.widgets.halp.zoom.tip3",
+    defaultMessage: "Read through the chat log where the request occured. There may be additional context in the log that can help you figure out how to get started:"
+  },
+});
+
+
+export default class ModalRequest extends Modal {
+
+  getModalBody() {
+    if (!this.props.data) { return ""; }
+    return (
+      <div className="zoomed-request">
+        {getRequestView(this.props.data)}
+        <hr />
+        <FormattedMessage
+          tagName="h4"
+          {...messages.zoom_part2_title}
+          />
+        <FormattedMessage
+          tag="p"
+          {...messages.zoom_part2_subtitle}
+          />
+        <ol>
+          { this.props.data.urls ?
+          <li>
+            <FormattedMessage
+              {...messages.zoom_tip1}
+              />
+            <ul>
+              { this.props.data.urls.map(function(url, index) {
+                return (
+                  <li key={index}><a href={url}>
+                    {url.replace(/^https?:\/\//, '')}
+                  </a></li>);
+                }) }
+            </ul>
+          </li>
+          : null }
+          <li>
+            <FormattedMessage
+              {...messages.zoom_tip2}
+              />
+            <ul style={{listStyleType: "none"}}>
+              <li className="media">
+                <div className="media-left media-middle">
+                  <a href={this.props.data.author.url} target="_blank">
+                    <img className="square-32 img-circle"
+                         src={this.props.data.author.avatar} />
+                  </a>
+                </div>
+                <div className="media-body">
+                  <a href={this.props.data.author.url} target="_blank">
+                    {this.props.data.author.name}
+                  </a>
+                </div>
+              </li>
+            </ul>
+          </li>
+          <li>
+            <FormattedMessage
+              {...messages.zoom_tip3}
+              />
+            <ul style={{listStyleType: "none"}}>
+              <a href={this.props.data.context_url}>
+                {this.props.data.context_url.replace(/^https?:\/\//, '')}
+              </a>
+            </ul>
+          </li>
+        </ol>
+      </div>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/Request.jsx b/hubs/static/client/app/widgets/halp/Request.jsx
new file mode 100644
index 0000000..bc80c6c
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Request.jsx
@@ -0,0 +1,40 @@
+import React from 'react';
+import {FormattedRelative} from 'react-intl';
+import getRequestView from './getRequestView.jsx';
+
+
+export default class Request extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.onClick = this.onClick.bind(this);
+  }
+
+  onClick(e) {
+    e.preventDefault;
+    this.props.onZoomRequest(this.props.request);
+  }
+
+  render() {
+    var requestView = getRequestView(
+      this.props.request,
+      this.props.onZoomRequest ? this.onClick : null);
+    return (
+      <div>
+        { this.props.showdate ?
+            <div className="date text-uppercase">
+              <FormattedRelative value={new Date(this.props.request.date * 1000)} />
+            </div>
+          : ""
+        }
+        {requestView}
+      </div>
+    );
+  }
+}
+Request.defaultProps = {
+    onZoomRequest: null,
+};
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/getRequestView.jsx b/hubs/static/client/app/widgets/halp/getRequestView.jsx
new file mode 100644
index 0000000..3e0296f
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/getRequestView.jsx
@@ -0,0 +1,65 @@
+import { FormattedMessage, defineMessages } from 'react-intl';
+import Linkify from 'react-linkify';
+
+
+const messages = defineMessages({
+  req_no_text: {
+    id: "hubs.widgets.halp.req_no_text",
+    defaultMessage: "(no message)"
+  },
+});
+
+
+export default function getRequestView(request, openCallback) {
+    var openButton = "";
+    if (openCallback) {
+      openButton = (
+        <div className="media-right media-middle">
+          <button className="btn btn-secondary btn-sm" onClick={openCallback}>
+            <span className="fa fa-chevron-right" aria-hidden="true"></span>
+          </button>
+        </div>
+      );
+    }
+    return (
+      <div className="request row">
+        <div className="hub col-sm-6">
+          <span>@{request.hub}</span>
+        </div>
+        <div className="channel col-sm-6">
+          {request.channel}
+        </div>
+        <div className="text col-sm-12">
+          { request.text ?
+            <Linkify>"{request.text}"</Linkify>
+          :
+            <em><FormattedMessage {...messages.req_no_text } /></em>
+          }
+        </div>
+        { request.url ?
+        <div className="url col-sm-12">
+          <a href={request.url}>
+            {request.url.replace(/^https?:\/\//, '')}
+          </a>
+        </div>
+        : null }
+        <div className="author media col-sm-12">
+          <div className="media-left media-middle">
+            <a href={request.author.url} target="_blank">
+              <img className="media-object square-32 img-circle"
+                   src={request.author.avatar} />
+            </a>
+          </div>
+          <div className="media-body">
+            <a href={request.author.url}>
+              {request.author.name}
+            </a>
+          </div>
+          {openButton}
+        </div>
+      </div>
+    );
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/webpack.config.js b/hubs/static/client/webpack.config.js
index ba91ad0..4bd3fd9 100644
--- a/hubs/static/client/webpack.config.js
+++ b/hubs/static/client/webpack.config.js
@@ -10,6 +10,7 @@ const config = {
     entry: {
         Hubs: path.join(PATHS.app, 'core', 'Hubs.js'),
         Feed: path.join(PATHS.app, 'widgets', 'feed', 'Feed.jsx'),
+        Halp: path.join(PATHS.app, 'widgets', 'halp', 'Halp.jsx')
     },
     output: {
         path: PATHS.build,
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index c9e8c39..2c8f1ff 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -83,7 +83,7 @@ class HubsAPITest(hubs.tests.APPTest):
             "name": "ralph",
             "owners": ["ralph"],
             "subscribers": [],
-            "widgets": [34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 56]
+            "widgets": [37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 61],
         }
         self.assertDictEqual(data, json.loads(result.get_data(as_text=True)))
 
